#include <avr/io.h>
#include "serial.h"
#include "messages.h"

//
// SendSFRStatus
// send SFR data to host

void SendSFRStatus(uint8_t SFRNo)
{
	msgSend.header.id = msgID_SFR;
	msgSend.header.cmd = msgCMD_GET_SFR;
	msgSend.param.item1 = SFRNo;
	msgSend.param.item2 = _SFR_IO8(SFRNo);

	msgSendLen = sizeof(msgSend.param);
	SendMessage();
}


void SendTimestamps(void)
{
	msgSend.header.id = msgID_DATA;
	msgSend.header.cmd = msgCMD_SEND_TS_DATA;

	for (int i=0; i<MAX_TIMESTAMPS; i++)
	{
		if (i<TimestampCount)
			msgSend.timestamps.values[i] = Timestamps[i];
		else
			msgSend.timestamps.values[i] = 0;
	}

	msgSendLen = sizeof(msgSend.timestamps);
	SendMessage();
}

void SendBitCode(void)
{
	msgSend.header.id = msgID_DATA;
	msgSend.header.cmd = msgCMD_SEND_BITCODE;

	msgSend.bitcode.value = BitCode;

	msgSendLen = sizeof(msgSend.bitcode);
	SendMessage();
}


