#ifndef _messages_h_
#define _messages_h_

#include "decoder.h"

// defines for Messages
#define MAX_MSGLEN	102

// IDs
#define msgID_BOOTLOADER 	 0x01
#define msgID_RFM	 		 0x02
#define msgID_SFR	 		 0x03
#define msgID_DATA	 		 0x04


// CMDs
#define msgUPLOADCODE  0xff

#define msgCMD_GET_RFM_REG  		0x01
#define msgCMD_SET_RFM_REG  		0x81

#define msgCMD_GET_SFR				0x01	
#define msgCMD_SET_SFR	  			0x81

#define msgCMD_SEND_TS_DATA			0x81	
#define msgCMD_SEND_BITCODE			0x82	






typedef struct
{
	uint8_t 	id;
	uint8_t		cmd;
} tHeader;

// union for accessing different messages in receive buffer
typedef union
{
	uint8_t	buffer[MAX_MSGLEN];
	tHeader	header;
	struct
	{
		tHeader 	header;
		uint16_t	item1;
		uint16_t	item2;
	} param;
	struct
	{
		tHeader 	header;
		uint16_t	values[MAX_TIMESTAMPS];
	} timestamps;
	struct
	{
		tHeader 	header;
		uint32_t	value;
	} bitcode;
} tMsg;


void SendSFRStatus(uint8_t SFRNo);
void SendTimestamps(void);
void SendBitCode(void);

#endif


