#ifndef _serial_h_
#define _serial_h_

#include "messages.h"

//
// fixed setting for UART speed
//

#define	UART_BPS	115200
// #define bauddivider (uint16_t)(F_CPU / UART_BPS / 16 - 0.5)
#define bauddivider (uint16_t)(F_CPU / UART_BPS / 8 - 0.5)



// typedefs and defines

typedef enum
{
	rcvState_WaitForSTX,
	rcvState_RcvData,
	rcvState_WaitForBCC,
	rcvState_ReceivedDLE,
	rcvState_MsgComplete
} rcvState_t;


#define STX	0x02
#define ETX 0x03
#define DLE 0x10



// globals

extern uint8_t	ErrorRcvLen;
extern uint8_t	ErrorBcc;
extern tMsg		msgRcv;
extern tMsg		msgSend;
extern uint8_t	bcc;
extern uint8_t	msgSendLen;
extern uint8_t	send_flag;

extern volatile rcvState_t	rcvState;
extern volatile uint8_t		msgLenRcv;


// function prototypes
void uart_putchar( char c );
void uart_puts( char *s );

void init_uart(void);
void ClearMessage(void);
void SendMessage(void);


#endif
